{% extends 'imicusfat/base.html' %}

{% load i18n %}
{% load bootstrap %}
{% load static %}

{% block page_title %}{% translate 'Fleet Activity' %}{% endblock %}

{% block imicusfat_header %}
    <br>
    {% include "imicusfat/menu.html" %}

    <h2>{% translate "Edit FAT Link" %}</h2>
{% endblock %}

{% block imicusfat_body %}
    {% if msg_code == 200 %}
        <div class="alert alert-success alert-dismissible" role="alert">
            <button type="button" class="close" data-dismiss="alert" aria-label="close">
                <span aria-hidden="true">&times</span>
            </button>

            <h4>{% translate "Success!" %}</h4>

            <p>&#9642; {% translate "FAT Link Created!" %}</p>
            <p>&#9642; {% translate "FATs have been queued, they may take a few mins to show up." %}</p>
            <p>&#9642; {% translate "Pilots who join later will be automatically added until you close or leave the fleet in-game." %}</p>
        </div>
    {% elif msg_code == 0 %}
        <div class="alert alert-danger alert-dismissible" role="alert">
            <button type="button" class="close" data-dismiss="alert" aria-label="close">
                <span aria-hidden="true">&times</span>
            </button>

            <h4>{% translate "Oh No!" %}</h4>

            <p>{% translate "Something went wrong!" %}</p>
        </div>
    {% elif msg_code == 202 %}
        <div class="alert alert-success alert-dismissible" role="alert">
            <button type="button" class="close" data-dismiss="alert" aria-label="close">
                <span aria-hidden="true">&times</span>
            </button>

            <h4>{% translate "Success!" %}</h4>

            <p>&#9642; {% translate "Clickable FAT Link Created!" %}</p>
            <p>&#9642; {% translate "Make sure to give your fleet members the following link to click so that they get credit for this fleet." %}</p>
            {% if link_ongoing %}
                <p>&#9642;
                    Link:
                    <i>
                        {{ request.scheme }}://{{ request.get_host }}{% url 'imicusfat:link_click' link.hash %}
                        <a class="label label-success copy-link" href="{% url 'imicusfat:link_click' link.hash %}"></a>
                    </i>

                    <button class="copy-btn btn btn-success btn-sm" data-toggle="tooltip" data-html="true" title="Copied!" data-clipboard-text="{{ request.scheme }}://{{ request.get_host }}{% url 'imicusfat:link_click' link.hash %}" style="margin-left: 1rem; background-color: rgba(255,255,255,0.3);">
                        Copy me!
                    </button>
                </p>
            {% endif %}
        </div>
    {% elif msg_code == 1 %}
        <div class="alert alert-success alert-dismissible" role="alert">
            <button type="button" class="close" data-dismiss="alert" aria-label="close">
                <span aria-hidden="true">&times</span>
            </button>

            <h4>{% translate "Success!" %}</h4>

            <p>{% translate "Fleet name successfully changed." %}</p>
        </div>
    {% elif msg_code == 3 %}
        <div class="alert alert-success alert-dismissible" role="alert">
            <button type="button" class="close" data-dismiss="alert" aria-label="close">
                <span aria-hidden="true">&times</span>
            </button>

            <h4>{% translate "Success!" %}</h4>

            <p>{% translate "Manual FAT processed." %}</p>
        </div>
    {% elif msg_code == 4 %}
        <div class="alert alert-danger alert-dismissible" role="alert">
            <button type="button" class="close" data-dismiss="alert" aria-label="close">
                <span aria-hidden="true">&times</span>
            </button>

            <h4>{% translate "Oh No!" %}</h4>

            <p>{% translate "Manual FAT processing failed! The character name you entered was not found." %}</p>
        </div>
    {% elif msg_code == 999 %}
        <div class="alert alert-{{ message.0 }} alert-dismissible" role="alert">
            <button type="button" class="close" data-dismiss="alert" aria-label="close">
                <span aria-hidden="true">&times</span>
            </button>
            <h4>
                {% if msg.0 == 'danger' %}
                    {% translate "Oh No!" %}
                {% elif msg.0 == 'success' %}
                    {% translate "Success!" %}
                {% endif %}
            </h4>
            <p>{{ message.1 }}</p>
        </div>
    {% endif %}

    <div class="col-md-12">
        <div class="row">
            <form class="form" role="form" action="" method="POST">
                {% csrf_token %}
                <div class="row">
                    <div class="col-md-12">
                        <div class="input-group">
                            <input type="text" class="form-control" placeholder='{% translate "Fleet Name" %}' name="fleet" {% if link.fleet %}value="{{ link.fleet }}" {% endif %}>

                            <span class="input-group-btn">
                                <button class="btn btn-primary" type="submit" name="set_name">{% translate "Set Name" %}</button>
                            </span>
                        </div>
                    </div>
                </div>
            </form>

            <p>&nbsp;</p>

            <div class="col-md-2">{% translate "Creator:" %} {{ link.creator.profile.main_character.character_name }}</div>
            <div class="col-md-2 col-md-offset-8">{% translate "Time:" %} {{ link.ifattime }}</div>

            {% if link_ongoing %}
            <div class="col-md-10">
                <p>Link:
                    <i>
                        {{ request.scheme }}://{{ request.get_host }}{% url 'imicusfat:link_click' link.hash %}
                        <a class="label label-success copy-link" href="{% url 'imicusfat:link_click' link.hash %}"></a>
                    </i>

                    <button class="copy-btn btn btn-success btn-sm" data-toggle="tooltip" data-html="true" title='{% translate "Copied!" %}' data-clipboard-text="{{ request.scheme }}://{{ request.get_host }}{% url 'imicusfat:link_click' link.hash %}" style="margin-left: 1rem;">
                        {% translate "Copy me!" %}
                    </button>
                </p>
            </div>
            {% endif %}
        </div>
    </div>

    <p>&nbsp;</p>

    <ul class="nav nav-tabs">
        <li class="active"><a data-toggle="tab" class="tab" href="#FATs">{% translate "FATs" %}</a></li>
        <li>{% if permissions.fats.add %}<a data-toggle="tab" class="tab" href="#manualfat">{% translate "Manual FAT" %}</a>{% endif %}</li>
        <li><a data-toggle="tab" class="tab" href="#flatlist">{% translate "Raw Data" %}</a></li>
    </ul>

    <div class="tab-content">
        <div id="FATs" class="tab-pane fade in active panel-default">
            <div class="panel-body">
                 <h4>{% translate "FATs for this FAT Link" %}</h4>

                 <table class="table" id="fat-chars" style="width: 100%;">
                     <thead>
                        <tr>
                            <th>{% translate "Character" %}</th>
                            <th>{% translate "Location" %}</th>
                            <th>{% translate "Ship Type" %}</th>
                            {% if permissions.fats.manage %}
                                <th>{% translate "Actions" %}</th>
                            {% endif %}
                        </tr>
                     </thead>

                     <tbody>
                        {% for fat in fats %}
                            <tr>
                                <td>{{ fat.character.character_name }}</td>
                                <td>{{ fat.system }}</td>
                                <td>{{ fat.shiptype }}</td>
                                {% if permissions.fats.delete %}
                                    <td>
                                        <a class="btn btn-danger"
                                            data-toggle="modal" data-target="#deleteModal"
                                            data-url="{{ request.scheme }}://{{ request.get_host }}{% url 'imicusfat:fat_delete' link.hash fat.id %}"
                                            data-name="{% if fat.character.character_name %}{{ fat.character.character_name }}{% else %}this pilot{% endif %}">
                                            <span class="glyphicon glyphicon-trash"></span>
                                        </a>
                                    </td>
                                {% endif %}
                            </tr>
                        {% endfor %}
                     </tbody>
                 </table>
            </div>
        </div>

        <div id="flatlist" class="tab-pane fade in panel-default">
            <div class="panel-body">
                <h4>{% translate "FAT Link Raw Data" %}</h4>
                <div class="form-group">
                    <textarea class="form-control" name="flatlist" rows="10" readonly>{% if flatlist %}{{ flatlist }}{% endif %}</textarea>
                </div>
            </div>
        </div>

        {% if permissions.fats.add %}
            <div id="manualfat" class="tab-pane fade in panel-default">
                <div class="panel-body">
                    <h4>{% translate "Manual FAT" %}</h4>

                    <p>
                        {% translate "Is someone missing from the list of FATs? Use this form to add them." %}
                        <br>
                        <strong>{% translate "Note:" %}</strong> {% translate "This action is logged!" %}
                    </p>

                    <form class="form" role="form" action="" method="POST">
                        {% csrf_token %}
                        <div class="form-group">
                            <div class="row">
                                <div class="col-md-12">
                                    <input type="text" class="form-control" id="character_name" name="character" placeholder='{% translate "Character Name" %}' required>
                                </div>
                            </div>
                        </div>

                        <div class="form-group">
                            <div class="row">
                                <div class="col-md-6">
                                    <input type="text" class="form-control" id="location" name="system" placeholder='{% translate "System" %}'>
                                </div>

                                <div class="col-md-6">
                                    <input type="text" class="form-control" id="shiptype" name="shiptype" placeholder='{% translate "Ship Type" %}'>
                                </div>
                            </div>
                        </div>

                        <button class="btn btn-primary btn-block" type="submit" name="manual_fat">{% translate "Add Manual FAT" %}</button>
                    </form>
                </div>
            </div>
        {% endif %}

    </div>

    <!-- Delete FAT Modal -->
    <div class="modal fade" id="deleteModal" tabindex="-1" role="dialog" aria-labelledby="deleteModalTitle" aria-hidden="true">
        <div class="modal-dialog modal-dialog-centered" role="document">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title" id="modalLongTitle">{% translate "Delete FAT" %}</h5>
                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                </div>

                <div class="modal-body"></div>

                <div class="modal-footer">
                    <button type="button" class="btn btn-secondary" data-dismiss="modal">{% translate "Cancel" %}</button>

                    <a id="fat-link" class="btn btn-danger" role="button" href="">{% translate "Delete" %}</a>
                </div>
            </div>
        </div>
    </div>
{% endblock %}

{% block extra_javascript %}
    {% include 'bundles/datatables-js.html' %}
    {% include 'bundles/clipboard-js.html' %}
{% endblock %}

{% block extra_css %}
    {% include 'bundles/datatables-css.html' %}

    <link rel="stylesheet" type="text/css" href="{% static 'imicusfat/css/aa-bootstrap-fix.min.css' %}">
{% endblock %}

{% block extra_script %}
    $(document).ready(function(){
        $('#fat-chars').DataTable();

        var clipboard = new ClipboardJS('.copy-btn');

        clipboard.on('success', function(e) {
            $('.copy-btn').tooltip('show');
        });

        $('#deleteModal').on('show.bs.modal', function (event) {
            var button = $(event.relatedTarget) // Button that triggered the modal
            var url = button.data('url') // Extract info from data-* attributes
            var name = button.data('name');

            var modal = $(this)
            modal.find('#fat-link').attr("href", url)
            modal.find('.modal-body').text('{% translate "Are you sure you want to delete" %} ' + name + '?');
        });
    });
{% endblock %}
